;
; CpcTerm: Transfert de fichiers AMSTRAD -> MAC
; (c)1996 Brice Rive
;
         org  #4000
         extra
;
         ld   de,HEAP
         call INITDISC
;
         scf
Menu
         call nc,Erreur
         call Affiche
         defb #0C,#04,#02,#1C,#00,#00
         defb #00,#1C,#01,#13,#13,#1D,#00,#00
         defb "CpcTerm: transfer to the Mac"
         defb #0A,#0D,"(c) 1996 B.RIVE."
         defb #0A,#0D,"Settings: 19200/8/2/None"
         defb #1F,#04,#05,"0 > Transfer ROM."
         defb #1F,#04,#06,"1 > Catalog."
         defb #1F,#04,#07,"2 > Transfer disk."
         defb #1F,#04,#08,"3 > Transfer file."
         defb #1F,#04,#09,"4 > End."
         defb #FF
MenuBcl  call #BB18
         sub  "0"
         jr   c,MenuBcl
         cp   5
         jr   nc,MenuBcl
         ld   hl,CommTab
         call CallIdx
         jp   Menu
;
CommTab
         defw Trom
         defw Cat
         defw Tdisk
         defw Tfile
         defw Quit
;
Quit     jp   #0000
;
Tfile
         call Affiche
         defb #0C,"Enter file name: ",#FF
         ld   b,32
         ld   hl,DiskName
         call EDIT
         ld   hl,DiskName
         ld   a,l
         add  a,b
         ld   l,a
         ld   a,0
         adc  a,h
         ld   h,a
         ld   (hl),0
         ld   hl,DiskName
         ld   de,HEAP
         call #BC77          ; DSK IN OPEN
         push bc
         jr   nc,Tfile0
         cp   2
         jr   nz,Tfile1
         ld   hl,HEAP+2048
         call #BC83
         jr   nc,Tfile0
         call #BC7A
         jr   nc,Tfile0
         ld   hl,HEAP+2048
         ld   de,DiskName
         ld   a,0
         ld   bc,#0201
         call InitTime
         pop  bc
         call SendBuff
         push bc
Tfile0   pop  bc
         ret
Tfile1
         pop  bc
         call #BC7A
         call Affiche
         defb #0C,"Can only transfer binary.",#FF
         call #BB06
         or   a
         ret
;
Trom
         call Affiche
         defb #0C,"Which ROM (Lower Upper Disk): ",#FF
         call #BB18
         cp   "u"
         jr   z,TromU
         cp   "l"
         jr   z,TromL
         cp   "d"
         jr   z,TromD
         or   a
         ret
TromL    call #B912          ; KL CURR SELECTION
         ld   c,a
         call #B906          ; KL L ROM ENABLE
         ld   b,a
         ld   hl,#0000
         ld   de,LRomName
         jr   Trom1
TromD    ld   c,#07
         ld   de,DRomName
         jr   TromU0
TromU    ld   c,#FF
         ld   de,URomName
TromU0   call #B90F          ; KL ROM SELECT
         ld   hl,#C000
Trom1    ld   bc,#0201
         call InitTime
         call SendRom
         call #B918          ; KL ROM DESELECT
         ret
;
LRomName defb "Lower ROM",#00
DRomName defb "ROM AMSDOS",#00
URomName defb "ROM BASIC",#00
;
SendRom
         push bc
         ld   bc,#4000
         call SendBuff
         pop  bc
         ret
;
Cat
         ld   a,1
         ld   (#ADA7),a      : Force recalibrate
         ld   de,HEAP
         call #BC9B
         call #BB06
         scf
         ret
;
DiskName defs 32
DiskTrac defs 1
;
Tdisk
         call Affiche
         defb #0C,"Enter disk name: ",#FF
         ld   b,32
         ld   hl,DiskName
         call EDIT
         ld   hl,DiskName
         ld   a,b            ;Name length
         add  a,l
         ld   l,a
         adc  a,h
         sub  l
         ld   h,a
         ld   (hl),0
         call Affiche
         defb #0A,#0D,"Scan type (Short Long VeryLong): ",#FF
         call #BB18
         ld   b,80
         cp   "v"
         jr   z,Tdisk1
         ld   b,59
         cp   "l"
         jr   z,Tdisk1
         ld   b,42
Tdisk1   xor  a
         ld   (DiskTrac),a
         ld   a,2                 ;Format version 2
         ld   (HEAP),a
         ld   hl,HEAP+2
         push bc
         ld   bc,#030F
         call InitTime
         pop  bc
         ld   a,0
         ld   (#ADA7),a      : Force recalibrate
Tdisk2   push bc
         ld   a,(DiskTrac)
         ld   d,a
         inc  a
         ld   (DiskTrac),a
         call SEEK
         call ANALYZE
         call c,Analyze2
         call NextTime
         ld   (hl),a         ; Nb Sectors
         call ShowTrak
         inc  hl
         ld   de,IDBUF       ; Analyze results
         jr   nc,Tdisk4      ; Skip track
         ld   b,a
Tdisk0   push bc
         ld   bc,8
         ex   de,hl
         ldir
         ex   de,hl
         pop  bc
         djnz Tdisk0         ; Next sector
Tdisk4   pop  bc
         push hl
         ld   a,66           ; Test ESC
         call #BB1E
         pop  hl
         ret  nz
         djnz Tdisk2         ; Next track
         ld   a,(DiskTrac)
         ld   (HEAP+1),a
         call Affiche
         defb #0A,#0A,#0D,"Transfer:",#FF
         ld   bc,#050F
         call InitTime
         call SendDisk
         ret
;
Analyze2
         push af
         push bc
         push de
         push hl
         ld   de,IDBUF
         ld   b,a
Ana20    push bc
         ld   hl,HEAP+8192
         call READ
         ld   a,(RESBUF)
         ld   (de),a
         inc  de
         ld   a,(RESBUF+1)
         ld   (de),a
         inc  de
         ld   a,(RESBUF+2)
         ld   (de),a
         push bc
         push de
         ld   de,-HEAP-8192
         dec  hl
         add  hl,de
         push hl
         pop  bc
         ld   hl,HEAP+8192
Ana21    ld   a,(hl)
         inc  hl
         cp   (hl)
         jr   nz,Ana23
         dec  bc
         ld   a,b
         or   c
         jr   nz,Ana21
         pop  de
         ld   a,(de)
         or   #80
         ld   (de),a
         ld   a,(hl)
         push de
Ana23    pop  de
         pop  bc
         inc  de
         ld   (de),a
         inc  de
         pop  bc
         djnz Ana20
         pop  hl
         pop  de
         pop  bc
         pop  af
         ret
;
; A nb sect
; DiskTrac
; IDBUF
ShowTrak
         push af
         push bc
         push de
         push hl
         push af
         ld   a,(DiskTrac)
         ld   b,a
         ld   hl,-8
         ld   de,8
ST00     add  hl,de
         djnz ST00
         ex   de,hl
         ld   hl,0
         call #BBC0          ;GRA MOVE ABSOLUTE
         pop  af
         ld   b,a
         inc  b
         ld   hl,IDBUF
         djnz ST0
         jr   ST1
ST0      push bc
         inc  hl
         inc  hl
         inc  hl
         ld   a,(hl)
         inc  hl
         inc  hl
         inc  hl
         inc  hl
         inc  hl
         push hl
         ld   b,#01
         inc  a
ST2      sla  b
         dec  a
         jr   nz,ST2
         dec  b
ST3      push bc
         ld   de,6
         ld   hl,0
         call #BBF9          ;GRA LINE RELATIVE
         ld   de,-6
         ld   hl,2
         call #BBC3          ;GRA MOVE RELATIVE
         pop  bc
         djnz ST3
         ld   de,0
         ld   hl,2
         call #BBC3          ;GRA MOVE RELATIVE
         pop  hl
         pop  bc
         djnz ST0
ST1      pop  hl
         pop  de
         pop  bc
         pop  af
         ret
         ld   (TimeX),de
         ld   hl,(TimeY)
         call #BBC0          ;GRA MOVE ABSOLUTE
         ld   de,0
         ld   hl,-8
         call #BBF9          ;GRA LINE RELATIVE
         pop  hl

;
Ttape
         ret
;
; HEAP->disk header
; DiskName->disk name
;
SendDisk
         call DiskLen
         ld   de,DiskName
         call MakeInfo
         ld   a,ESC
         call PutA
         ld   a,"a"
         call PutA
         call GetA
         jp   nc,SendDsk0
         cp   ACK
         jr   nz,SendDsk0
         push bc
         push hl
         ld   a,1            ; more
         ld   hl,InfoBuff
         ld   bc,NBytes
         call SendFile
         pop  hl
         pop  bc
         jr   nc,SendDsk0
         call SendTrac
         jr   nc,SendDsk0
         ld   bc,0
         ld   a,0            ; no more
         call SendFile
         jr   nc,SendDsk0
         ret
SendDsk0 or   a
         ret
;
DiskLen
         ld   hl,0
         ld   (Length),hl
         ld   (Length+2),hl
         ld   a,#20               ; Header size = 8192
         ld   (Length+3),a
         ld   hl,HEAP+1
         ld   b,(hl)              ; nb tracks
         inc  hl
DiskLen1 push bc
         ld   b,(hl)              ; nb sectors
         inc  hl
         ld   a,b
         or   a
         jr   z,DiskLen4
DiskLen2 inc  hl
         inc  hl
         inc  hl
         push bc
         ld   b,(hl)              ; sector size
         ld   a,6                 ; clip to 8192
         cp   b
         jr   nc,DiskLen5
         ld   b,6
DiskLen5 inc  hl
         inc  hl
         inc  hl
         bit  7,(hl)
         inc  hl
         inc  hl
         jr   nz,DiskLen6
         ld   de,#0040            ; 128 bytes
         inc  b
DiskLen3 sla  e
         rl   d
         djnz DiskLen3
         push hl
         ld   hl,(Length+2)
         add  hl,de
         ld   (Length+2),hl
         ld   hl,(Length)
         ld   de,0
         adc  hl,de
         ld   (Length),hl
         pop  hl
DiskLen6 pop  bc
         djnz DiskLen2
DiskLen4 pop  bc
         djnz DiskLen1
         ld   a,(Length)     ; reorder length bytes
         ld   d,a
         ld   a,(Length+1)
         ld   (Length),a
         ld   a,d
         ld   (Length+1),a
         ld   a,(Length+2)
         ld   d,a
         ld   a,(Length+3)
         ld   (Length+2),a
         ld   a,d
         ld   (Length+3),a
         ret
;
SendTrac
         ld   a,0
         ld   (RecNo),a
         ld   b,64           ; 8192 bytes header
         ld   hl,HEAP
SendTr0  push bc
         ld   a,(RecNo)
         inc  a
         ld   (RecNo),a
SendTr01 ld   bc,NBytes
         call SendRec
         call GetA
         cp   NAK
         jr   z,SendTr01
         cp   ACK
         jp   nz,SendTraB
         ld   bc,NBytes
         add  hl,bc
         pop  bc
         djnz SendTr0
         xor  a
         ld   (DiskTrac),a
         ld   hl,HEAP+1
         ld   b,(hl)         ; nb tracks
         inc  hl
SendTra1 push bc
         ld   b,(hl)         ; nb sectors
         inc  hl
         ld   a,(DiskTrac)
         ld   d,a
         inc  a
         ld   (DiskTrac),a
         call SEEK
         ld   a,b
         or   a
         jr   z,SendTra6
SendTra2 push bc
         ex   de,hl
         ld   hl,HEAP+8192
         call READ
         ex   de,hl
         dec  hl
         ld   b,(hl)         ; sector size
         ld   a,6            ; clip to 8192
         cp   b
         jr   nc,SendTra7
         ld   b,6
SendTra7 inc  hl
         inc  hl
         inc  hl
         bit  7,(hl)
         inc  hl
         inc  hl
         jr   nz,SendTra9
         push hl
         inc  b              ; number of 128 bytes blocks
         xor  a
         scf
SendTra3 rla
         djnz SendTra3
         ld   b,a            ; number of blocks
         ld   hl,HEAP+8192
SendTra4 push bc
         ld   a,(RecNo)
         inc  a
         ld   (RecNo),a
SendTra5 ld   bc,NBytes
         call SendRec
         call GetA
         cp   NAK
         jr   z,SendTra5     ; retry
         cp   ACK
         jr   nz,SendTraA
         ld   bc,NBytes
         add  hl,bc
         pop  bc
         djnz SendTra4       ; next block
         pop  hl
SendTra9 pop  bc
         djnz SendTra2       ; next sector
SendTra6 pop  bc
         call NextTime
         djnz SendTra1       ; next track
SendTra8 ld   a,EOT
         call PutA
         call GetA
         call GetA
         scf
         ret
SendTraA pop  bc
         pop  hl
         pop  bc
SendTraB pop  bc
         or   a
         ret

; hl=address
; bc=length
; de=name
SendBuff
         ld   a,b
         ld   (Length+2),a
         ld   a,c
         ld   (Length+3),a
         xor  a
         ld   (Length),a
         ld   (Length+1),a
         call MakeInfo
         ld   a,ESC
         call PutA
         ld   a,"a"
         call PutA
         call GetA
         jp   nc,SendBuf0
         cp   ACK
         jr   nz,SendBuf0
         push bc
         push hl
         ld   hl,InfoBuff
         ld   bc,NBytes
         ld   a,1
         call SendFile
         pop  hl
         pop  bc
         jr   nc,SendBuf0
         ld   a,1
         call SendFile
         jr   nc,SendBuf0
         ld   bc,0
         ld   a,0
         call SendFile
         jr   nc,SendBuf0
         ret
SendBuf0 or   a
         ret
;
NBytes   equ  128
InfoBuff defs NBytes
Length   equ  InfoBuff+83
InfoStd  defb "DATACPC ",#00,#00
RecNo    defs 1
ACK      equ  #06
DUP      equ  #00
SOH      equ  #01
EOT      equ  #04
NAK      equ  #15
CAN      equ  #18
EEF      equ  #1A
ESC      equ  #1B
;
MakeInfo
         push de
         push af
         push hl
         push bc
         ld   hl,InfoBuff+2
         ex   de,hl
         ld   c,-1
MakeInf0 ld   a,(hl)
         ld   (de),a
         inc  hl
         inc  de
         inc  c
         or   a
         jr   nz,MakeInf0
         ld   a,c
         ld   (InfoBuff+1),a
         ld   hl,InfoStd
         ld   de,InfoBuff+65
         ld   bc,10
         ldir
         pop  bc
         pop  hl
         pop  af
         pop  de
         ret
;
; hl=address
; bc=nbytes
SendFile
         push af
         ld   a,b
         or   c
         jr   z,SendFil5
         push bc
         ld   a,1
         ld   (RecNo),a
SendFil1 ld   bc,NBytes
         call SendRec
         call NextTime
         call GetA
         cp   NAK
         jr   z,SendFil1
         cp   ACK
         jr   nz,SendFil9
         add  hl,bc
         pop  de
         push hl
         ld   hl,NBytes
         ex   de,hl
         scf
         sbc  hl,de
         ex   de,hl
         pop  hl
         jr   c,SendFil5
         inc  de
         push de
         ld   a,(RecNo)
         inc  a
         ld   (RecNo),a
         jr   SendFil1
SendFil5 ld   a,EOT
         call PutA
         call GetA
         pop  af
         or   a
         jr   z,SendFil6
         call GetA
SendFil6 scf
         ret
SendFil9 pop  af
         pop  bc
         or   a
         ret
;
SendRec
         ld   a,SOH
         call PutA
         push hl
         ld   hl,RecNo
         ld   a,(hl)
         call PutA
         ld   a,#FF
         sub  (hl)
         call PutA
         pop  hl
         call PutRec
         ld   a,e
         call PutA
         ret
;
PutTemp  defb #04          ; 19200bauds,8bits,none,2stop
GetTemp  defb #03
StartTmp defb #07
;
PutRec
         push hl
         push bc
         ld   e,0
PutRec0  ld   a,(hl)
         add  a,e
         ld   e,a
         ld   a,(hl)
         call PutA
         inc  hl
         dec  bc
         ld   a,b
         or   c
         jr   nz,PutRec0
         pop  bc
         pop  hl
         ret
;
PutA
         di
         push bc
         ld   c,a
         ld   b,8            ; Put 8 bits
         xor  a
         call PutCar         ; Put start bit
PutA0    xor  c              ; Update parity
         srl  c              ; Get next bit into carry
         call PutCar         ; Put data bit
         djnz PutA0
         srl  a              ; Get parity into carry
;        call PutCar         ; Put parity bit
         scf
         call PutCar         ; Reset line to high (stop bits)
         call PutCar
         pop  bc
         ret
;
PutCar
         push bc             ;[11]
         push af             ;[11]
         ld   b,#EF          ;[07] Centronics port adress
         sbc  a,a            ;[04] Set bits according to carry
         out  (c),a          ;[12] Put data
         ld   a,(PutTemp)    ;[07]
PutCar0  dec  a              ;[04]
         jr   nz,PutCar0     ;[12/7]
         pop  af             ;[10]
         pop  bc             ;[10]
         ret                 ;[10]
;
GetRec
         call GetA
         jr   c,GetRec1
         ld   (hl),a
         inc  hl
         dec  bc
         ld   a,b
         or   c
         jr   nz,GetRec
         scf
         ret
GetRec1  ccf
         ret

GetA
         di
         push bc
         ld   b,#F5          ; 8255 port B
GetA0    in   a,(c)          ; Wait for start bit
         rla
         rla
         jr   c,GetA0
         ld   a,(StartTmp)
GetA2    dec  a              ; Wait till middle of next bit
         jr   nz,GetA2
         xor  a
         ld   bc,#0800
GetA1    call GetCar         ; Get data bit
         rr   c
         xor  c              ; Update parity
         djnz GetA1
         call GetCar         ; Get parity bit
         rra
         and  #C0            ; Check parity
         ld   a,c
;        jp   po,ParErr
         pop  bc
         scf
         ret
ParErr   or   a
         pop  bc
         ret
;
GetCar
         push bc
         ld   c,a
         ld   b,#F5          ; 8255 port B
         in   a,(c)
         rla                 ; Get bit 6 into carry
         rla
         push af
         ld   a,(GetTemp)
GetCar0  dec  a
         jr   nz,GetCar0
         pop  af
         ld   a,c
         pop  bc
         ret
;
         select disk.lib
         select gui.lib
;