*******************************************************************************
;ROUTINES DE DIALOGUE AVEC LE FDC 765
;(c)1993 Brice Rive
;*******************************************************************************
;
RESBUF   DEFS 20
;
SETDRIVE
         PUSH AF
         PUSH HL
         PUSH BC
         PUSH DE
         LD   B,A
         LD   HL,DRIVES
SETDRI10 LD   E,(HL)
         INC  HL
         LD   D,(HL)
         INC  HL
         LD   A,D
         OR   E
         JR   Z,SETDRI11
         INC  DE
         LD   A,(DE)
         AND  #FE
         OR   B
         LD   (DE),A
         JR   SETDRI10
SETDRI11 POP  DE
         POP  BC
         POP  HL
         POP  AF
         RET

DRIVES
         DEFW DRIVE2
         DEFW DRIVE3
         DEFW DRIVE7
         DEFW 0
;
IDBUF    DEFS 2048
BADSECT  DEFB #D0,#00,#00,#01
;
ANALYZE
         PUSH BC
         PUSH HL
         PUSH DE
         LD   DE,BADSECT
         CALL READ                ; DO DUMMY READ TO SYNC WITH END OF TRACK
         LD   BC,-1
         LD   DE,IDBUF
ANA0     CALL READID
         JR   NC,ANA3
         INC  BC
         PUSH DE
         LD   DE,IDBUF
         LD   B,4
         LD   HL,RESBUF+3
ANA1     LD   A,(DE)
         CP   (HL)
         JR   Z,ANA2
         POP  DE
         LD   HL,RESBUF+3
         PUSH BC
         LD   BC,8
         LDIR
         POP  BC
         JR   ANA0
ANA2     INC  HL
         INC  DE
         DJNZ ANA1
         LD   A,C
         SCF
         POP  DE
ANA3     POP  DE
         POP  HL
         POP  BC
         RET
;
READID
         PUSH BC
         PUSH HL
         DI
         LD   A,#4A
         CALL FDCOUT
DRIVE2   LD   A,0
         CALL FDCOUT
         CALL RESULT
         LD   A,(RESBUF)
         RLA
         RLA
         CCF
         POP  HL
         POP  BC
         RET
;
; Read a max of 8192 bytes
; hl=dest,de=sect addr ptr
READ
         PUSH BC
         PUSH IX
         LD   A,(DE)
         LD   (TRACK3+1),A
         INC  DE
         LD   A,(DE)
         LD   (HEAD3+1),A
         INC  DE
         LD   A,(DE)
         LD   (SECTOR3+1),A
         LD   (SECTOR4+1),A
         INC  DE
         LD   A,(DE)
         LD   (SIZE3+1),A
         INC  DE
         DI   
         LD   A,#46                     ;Lire donnees
         CALL FDCOUT
DRIVE3   LD   A,0
         CALL FDCOUT
TRACK3   LD   A,0
         CALL FDCOUT
HEAD3    LD   A,0
         CALL FDCOUT
SECTOR3  LD   A,0
         CALL FDCOUT
SIZE3    LD   A,0
         CALL FDCOUT
SECTOR4  LD   A,0
         CALL FDCOUT
         LD   A,#2A
         CALL FDCOUT
         LD   A,#FF
         CALL FDCOUT
         PUSH DE
         PUSH HL
         POP  IX
         LD   HL,#0000       ; no initial skip
         LD   DE,#2000       ; 8192 bytes max
         CALL NDATAIN
         CALL RESULT
         PUSH IX
         POP  HL
         POP  DE
         POP  IX
         POP  BC
         RET  
;
SEEK
         PUSH BC
         PUSH DE
         PUSH HL
DRIVE7   LD   E,0
         RST  #18
         DEFW SEEKCOM
         POP  HL
         POP  DE
         POP  BC
         RET

SEEKCOM  DEFW #C763
         DEFB #07
;
FDCOUT
         LD   BC,#FB7E
         PUSH AF
WAITRQM  IN   A,(C)
         ADD  A,A
         JR   NC,WAITRQM
         ADD  A,A
         JR   NC,OKOUT
         POP  AF
         RET  
OKOUT    POP  AF
         INC  C
         OUT  (C),A
         DEC  C
         LD   A,05
FDCTEMP  DEC  A
         NOP
         JR   NZ,FDCTEMP
         RET  
;
RESULT
         PUSH HL
         LD   HL,RESBUF
RESAGAIN IN   A,(C)
         CP   #C0
         JR   C,RESAGAIN
         INC  C
         IN   A,(C)
         DEC  C
         LD   (HL),A
         INC  HL
         LD   A,#05
RESTEMP  DEC  A
         JR   NZ,RESTEMP
         IN   A,(C)
         AND  #10
         JR   NZ,RESAGAIN
         POP  HL
         RET
;
DATAIN
         LD   BC,#FB7E
         JR   DATAIN1
DATAIN0  INC  C
         IN   A,(C)
         LD   (HL),A
         DEC  C
         INC  HL
DATAIN1  IN   A,(C)
         JP   P,DATAIN1
         AND  #20
         JR   NZ,DATAIN0
         RET  
;
NDATAI0  INC  C
         IN   A,(C)
         DEC  C
         DEC  HL
NDATAIN  LD   A,H
         OR   L
         JR   Z,NDATAI2
NDATAI1  IN   A,(C)
         JP   P,NDATAI1
         AND  #20
         JR   NZ,NDATAI0
         RET
NDATAI2  PUSH IX
         POP  HL
         JR   NDATAI4
NDATAI3  INC  C
         INI
         DEC  C
         INC  B
         DEC  DE
         LD   A,D
         OR   E
         JR   Z,NDATAI5
NDATAI4  IN   A,(C)
         JP   P,NDATAI4
         AND  #20
         JR   NZ,NDATAI3
         PUSH HL
         POP  IX
         RET
NDATAI5  PUSH HL
         POP  IX
         LD   HL,0
         JR   NDATAI1
;
INITDISC
         LD   HL,COMMAND
         CALL #BCD4
         JR   NC,INITROM
         XOR  A
         JP   #1B
INITROM  LD   C,7
         LD   DE,#40
         LD   HL,#B0FF
         CALL #BCCE
         JR   INITDISC

COMMAND  DEFB "DIS","C"+#80
;
