*******************************************************************************
;ROUTINES DE DIALOGUE AVEC L'UTILISATEUR
; (c)1993 Brice Rive
;*******************************************************************************

; b:Line c:Column
TimeX    defs 2
TimeY    defs 2
InitTime
         push hl
         ld   h,0
         ld   l,c
         dec  l
         sla  l
         rl   h
         sla  l
         rl   h
         sla  l
         rl   h
         dec  hl
         ld   (TimeX),hl
         ld   h,0
         ld   l,b
         dec  l
         sla  l
         rl   h
         sla  l
         rl   h
         sla  l
         rl   h
         sla  l
         rl   h
         push hl
         pop  bc
         ld   hl,397
         sbc  hl,bc
         ld   (TimeY),hl
         call NextTime
         pop  hl
         ret
NextTime
         push af
         push bc
         push de
         push hl
         ld   de,(TimeX)
         inc  de
         ld   (TimeX),de
         ld   hl,(TimeY)
         call #BBC0          ;GRA MOVE ABSOLUTE
         ld   de,0
         ld   hl,-8
         call #BBF9          ;GRA LINE RELATIVE
         pop  hl
         pop  de
         pop  bc
         pop  af
         ret
;
INDICE   DEFS 1
;
EDIT
         LD   (POINTE+1),HL
         PUSH BC
         XOR  A
         LD   (INDICE),A
         LD   A,32
NEWTXT   LD   (HL),A
         INC  HL
         DJNZ NEWTXT
         POP  BC
EDITBCLE PUSH BC
         LD   HL,(POINTE+1)
AFFTXT   LD   A,(HL)
         CALL #BB5A
         INC  HL
         DJNZ AFFTXT
         POP  BC
         PUSH BC
AFFBCK   LD   A,#08
         CALL #BB5A
         DJNZ AFFBCK
         POP  BC
         CALL #BB18
         CP   #0D                           ;RETURN
         JR   Z,EDEND
         CP   #8B                           ;ENTER
         JR   Z,EDEND
         CP   #FC                           ;ESCAPE
         RET  Z
         CP   #7F                           ;DELETE
         JR   NZ,NOTDEL
         LD   A,(INDICE)
         OR   A
         JR   Z,EDITBCLE
         CALL POINTE
         LD   (HL),32
         LD   HL,INDICE
         DEC  (HL)
         JR   EDITBCLE
NOTDEL   CP   #20
         JR   C,EDITBCLE
         LD   HL,INDICE
         LD   C,A
         LD   A,(HL)
         CP   B
         JR   Z,EDITBCLE
         INC  (HL)
         CALL POINTE
         LD   (HL),C
         JR   EDITBCLE
EDEND    LD   A,(INDICE)
         LD   B,A
         SCF
         RET
POINTE
         LD   HL,0000
         LD   A,(INDICE)
         DEC  A
         ADD  A,L
         LD   L,A
         RET  NC
         INC  H
         RET
;
;
AFFHL
         LD   A,H
         CALL AFFA
         LD   A,L
AFFA
         PUSH AF
         RRA
         RRA
         RRA
         RRA
         CALL AFFDIGIT
         POP  AF
         PUSH AF
         CALL AFFDIGIT
         POP  AF
         RET
AFFDIGIT
         AND  #0F
         ADD  A,"0"
         CP   ":"
         JR   C,OKNUMBER
         ADD  A,7
OKNUMBER JP   #BB5A
;
Affiche
         EX   (SP),HL
         PUSH AF
AFFICH1  LD   A,(HL)
         INC  HL
         CP   #FF
         JR   NZ,AFFICH0
         POP  AF
         EX   (SP),HL
         RET  
AFFICH0  CALL #BB5A
         JR   AFFICH1
;
;
; Call a routine through an index table
;   ->   A  = index of the routine to select
;        HL = table containing all the routine adresses
;
CallIdx
         SLA  A
         PUSH DE
         LD   D,0
         LD   E,A
         ADD  HL,DE
         POP  DE
         LD   A,(HL)
         INC  HL
         LD   H,(HL)
         LD   L,A
         OR   H
         RET  Z
         JP   (HL)
;
Erreur
         CALL Affiche
         DEFB #0C,#1F,#05,#19
         DEFB "**** ABANDON ****"
         DEFB #0A,#0A,#0A,#0A,#0A
         DEFB #0A,#0A,#0A,#0A,#0A
         DEFB #0A,#0A,#0A,#0A,#0A
         DEFB #0A,#0A,#0A,#0A,#0A
         DEFB #0A,#0A,#0A,#0A,#0A
         DEFB #FF
         RET
;
HEAP     EQU  $
;